# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/00a_core.granularity.ipynb.

# %% auto 0
__all__ = ['granularities', 'available_granularities']

# %% ../../nbs/00a_core.granularity.ipynb 2
import torch
import torch.nn as nn
import torch.nn.functional as F
from fastcore.basics import *
from fastcore.imports import *

# %% ../../nbs/00a_core.granularity.ipynb 5
_granularities_Conv2d = {'weight':0, 'shared_weight':1, 'channel':2, 'column':3, 'row':4, 'kernel':(3,4), 'filter':(2,3,4), 'shared_channel':(1,2), 'shared_column': (1,3), 'shared_row': (1,4), 'vertical_slice': (2,3), 'horizontal_slice': (2,4), 'shared_vertical_slice': (1,2,3), 'shared_horizontal_slice': (1,2,4), 'shared_kernel': (1,3,4), 'layer':(1,2,3,4)}

# %% ../../nbs/00a_core.granularity.ipynb 46
_granularities_Linear = {'weight':0, 'column':1, 'row':2, 'layer':(1,2)}

# %% ../../nbs/00a_core.granularity.ipynb 60
granularities = {'Conv2d': _granularities_Conv2d, 'QuantConv2d': _granularities_Conv2d , 'Linear': _granularities_Linear, 'Conv1D': _granularities_Linear}

# %% ../../nbs/00a_core.granularity.ipynb 61
def available_granularities():
    for k in granularities.keys():
        print('Layer Type:', k)
        print('Granularities:', list(granularities[k].keys()))
        print('\n')
